﻿// Licensed Materials - Property of IBM
//
// Matrix.js
//
// (c) Copyright IBM Corporation 2007, 2008.  All Rights Reserved.
//
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

// ######## variables ########

// aArray = array
// tableid = Table ID
// aIndex = Number
// aObject = Object

function Mrix(aArray){
  this.mArray = aArray || [];
}

function GenerateForm(tableid){
	var table = document.getElementById(tableid);
	var rows = table.getElementsByTagName("tr");
    var matrixformtext = '<div id="matrixwrapper"><form id="Form1" method="POST" runat="server" target="_blank" action="popMatrix.aspx">'
    matrixformtext = matrixformtext + '<input type="hidden" id="hiddenMatrixTab" name="matrixTab">'
    matrixformtext = matrixformtext + '<input type="hidden" id="hiddenMatrixTitle" name="matrixTitle"><p>';
	var matrixformselection = '';

	row1 = rows[0].childNodes
	
	
	for (var k=0;k<(row1.length);k++){
	   if(document.all){
	        matrixformselection = matrixformselection + '<option value=\'' + row1[k].innerText + '\'>' + row1[k].innerText +'</option>';
	      }
	    else if (trim(row1[k].textContent) != "") {
	        matrixformselection = matrixformselection + '<option value=\'' + row1[k].textContent + '\'>' + row1[k].textContent + '</option>';
	      }
	 }
	
	var selectionRow  = '<div id="divformrowname"><select size="1" id="formrowname">' + matrixformselection + '</select>Row<br></div>';
	var selectionCol  = '<div id="divformcolname"><select size="1" id="formcolname">' + matrixformselection + '</select>Column<br></div>';
	var xinCell = '<option value="X" selected>X in Cell</option>'
	var selectionCell  = '<div id="divformcellname"><select size="1" id="formcellname">' + xinCell + matrixformselection + '</select>Cell<br></div>';

	matrixformtext = matrixformtext + selectionRow + selectionCol + selectionCell
	matrixformtext = matrixformtext +  '<div id="divbuttons">';
	matrixformtext = matrixformtext +  '<input type="submit" class="submit small" value="Matrix" onclick="SubmitForm(\'' + tableid + '\')" >&nbsp;&nbsp;'
	matrixformtext = matrixformtext +  '<input type="reset" class="submit small" value="Reset">'
	matrixformtext = matrixformtext +  '</div>'
	matrixformtext = matrixformtext +  '</p></form></div>';

	var matrixform = document.getElementById('matrix');

    if (document.all){
	  if(matrixform !=null){
	    if( matrixform.innerText.toString() ==''){
			matrixform.innerHTML = matrixformtext;
			matrixform.style.display = 'none'
		   }
		}
	}
   else {
    if(matrixform.textContent.toString() ==''){
		matrixform.innerHTML = matrixformtext;
		    matrixform.style.display = 'none';
		}
	}

	if(matrixform.style.display == '' ){ 
	    matrixform.style.display = 'none';
	}
	else{ 
	    matrixform.style.display = '';  
	}

}

function SubmitForm(tableid){
	var rowname = document.getElementById("formrowname").options[document.getElementById("formrowname").selectedIndex].value;
	var colname = document.getElementById("formcolname").options[document.getElementById("formcolname").selectedIndex].value;
	var cellname = document.getElementById("formcellname").options[document.getElementById("formcellname").selectedIndex].value;
    BuildMatrix(tableid, rowname ,colname , cellname)
}

function BuildMatrix(tableid, rowname, colname, cellname){
	var table = document.getElementById(tableid);
	var rows = table.getElementsByTagName("tr");
	var listRows = new Mrix();
	var listCols = new Mrix();
	var matrixTable = '';
	listRows.addUnique("<br>")
	listCols.addUnique("<br>")
	var row0col0 = "";
	var row1, rowpos, colpos, cellpos, celltext
	row0col0 = rowname +' / ' +  colname ;
	row1 = rows[0].childNodes

	// Find the position of row, col and cell
	if(document.all){
	for(var k=0;k<(row1.length);k++){
		if(row1[k].innerText == rowname) rowpos = k
		if(row1[k].innerText == colname) colpos = k
		if(cellname != 'X'){
		    if(row1[k].innerText == cellname) cellpos = k
		}
	}
	}
	else{
	for(var k=0;k<(row1.length);k++){
		if(row1[k].textContent == rowname) rowpos = k
		if(row1[k].textContent == colname) colpos = k
		if(cellname != 'X'){
		    if(row1[k].textContent == cellname) cellpos = k
		}
	}
	}

	if(rows.length>1 ){
		c= rows[0].childNodes;
		totalcols=c.length;
	}
	// Populate column items from the second column of the table
	for(i=1; i<rows.length;i++){
		c=rows[i].childNodes;
		for(var k=0;k<(c.length);k++){
			if(k == rowpos){
				listRows.addUnique(c[k].innerHTML);
			}
			if(k == colpos){
				listCols.addUnique(c[k].innerHTML);
			}
		}
	}

	var rowLength = listRows.getLength();
	var colLength = listCols.getLength();

	// Build two dimention array
	var Matrix = new Array(rowLength)
	for(x = 0; x <= rowLength; x++) {Matrix [x] = new Array(colLength)}

	// Load Matrix Col and Row name
	for(r = 0; r < rowLength; r++){
		for(c = 0; c < colLength; c++){
		     Matrix [r] [c] = "";
		     if((c == 0 ) && (r == 0)) Matrix[r] [c] = row0col0;
		     if((r == 0 ) && (c != 0)) Matrix[r] [c] =  listCols.getAt(c);
		     if((c == 0 ) && (r != 0)) Matrix[r] [c] =  listRows.getAt(r);
		}
	}

	// Load Matrix Cell
	for(i=1; i<rows.length;i++){
		c=rows[i].childNodes;

		for(var k=0;k<(c.length);k++){
			if (k == rowpos) var RowPos = listRows.findIndexOf(c[k].innerHTML);
			if (k == colpos) var ColPos = listCols.findIndexOf(c[k].innerHTML);
			if (k == cellpos) celltext = c[k].innerHTML;
		}
		if(cellname != 'X'){
		    Matrix [RowPos] [ColPos]  = celltext;
		}
		else{ 
		    Matrix [RowPos] [ColPos] = cellname; 
		}
	}

	// Build Matrix Result Table
	 matrixTable = matrixTable + "<table border='1px' id='"+tableid+"' cellspacing='0'>";
	     for(r = 0; r < rowLength; r++){
	 	    matrixTable = matrixTable + "<tr>";
	        for(c = 0; c < colLength; c++){
		        if(Matrix [r] [c] != ''){ 
		            matrixTable = matrixTable + "<td>" + Matrix [r] [c] + "</td>"; 
		        }
		        else{ 
		            matrixTable = matrixTable + "<td><br></td>";
		        }
	        }
	        matrixTable = matrixTable + "</tr>";
	     }
	     matrixTable = matrixTable + "</table>";
	    
	     document.getElementById('hiddenMatrixTab').value = matrixTable;
	     document.getElementById('hiddenMatrixTitle').value = row0col0;
	       	
	}

Mrix.prototype.getLength = function(){
    return this.mArray.length;
}

Mrix.prototype.getAt = function(aIndex){
    if(aIndex < 0 || aIndex >= this.mArray.length){
        return undefined;
    }

    return this.mArray[aIndex];
}

Mrix.prototype.removeAt = function (aIndex){
    var length = this.mArray.length;
    if(length  == 0){
        return;
    }

    switch(aIndex) {
        case -1:
            break;
        case 0:
            this.mArray.shift();
            break;
        case length - 1:
            this.mArray.pop();
            break;
        default:
            var head = this.mArray.slice(0, aIndex);
            var tail = this.mArray.slice(aIndex+1);
            this.mArray = head.concat(tail);
            break;
    }
}

Mrix.prototype.findIndexOf = function(aObject){
    var length = this.mArray.length;
    for(var i = 0; i < length; ++i){
        if(this.mArray[i] == aObject){
            return i;
        }
    }
    return -1;
}

Mrix.prototype.addUnique = function (aObject){
    var i = this.findIndexOf(aObject);
    if(i == -1){
        this.mArray[this.mArray.length] = aObject;
    }
}




