﻿// Licensed Materials - Property of IBM
// chart.js
// Portions of this file are (c) Copyright IBM Corporation 2007, 2008.  All Rights Reserved.
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.


// svg chart SCRIPT

      ColorArray = new Array("forestgreen", 
                             "maroon", 
                             "orangered",
                             "orange",
                             "olive", 
                             "orchid", 
                             "steelblue", 
                             "darkcyan", 
                             "yellowgreen", 
                             "yellow",
                             "purple", 
                             "royalblue", 
                             "deeppink",
                             "slategrey",
                             "saddlebrown");
                             
      ActiveSegment = "Pie";
          
      CurrentColor = 0;
      
      SVGDocument = null;
    
      BarChartHeight = 150;
      BarChartWidth  = 250;
      
      PieChartSize = 140;
      
      MoveDistance = 30;
    
      Values = new Array();
      Names = new Array();
      Colors = new Array();
      PieElements = new Array();
      BarElements = new Array();
      BarTexts = new Array();
      DeleteList = new Array();
      
      PieTotalSize = 0;
      BarTotalSize = 0;
      MaxSize = 0;
      

      
      AngleFactor = Math.pow(2, .5);
      
      Removed = false;
      
      function ClearChart()
        {
          for (var I = 0; I < PieElements.length; I++)
            {
              ParentGroup1.removeChild(PieElements[I]);
              ParentGroup2.removeChild(BarElements[I]);
              SVGDocument.getElementById("labels").removeChild(Colors[I]);
              SVGDocument.getElementById("labels").removeChild(Names[I]);
            }
            
          PieElements = new Array();
          BarElements = new Array();
          BarTexts = new Array();
          Values = new Array();
          Names = new Array();
          Colors = new Array();
          PieTotalSize = 0;
          BarTotalSize = 0;
          MaxSize = 0;
          if (!(Removed))
            {
              Grandparent1.removeChild(ParentGroup1);
              Grandparent2.removeChild(ParentGroup2);
            }
          Removed = true;
          
        }
      
      function Initialize(LoadEvent)
        {
          
          SVGDocument = LoadEvent.getTarget().getOwnerDocument();
          ParentGroup1 = SVGDocument.getElementById("slices");
          Grandparent1 = SVGDocument.getElementById("piechart");
          ParentGroup2 = SVGDocument.getElementById("bars");
          Grandparent2 = SVGDocument.getElementById("barchart");
          
          SVGDocument.getDocumentElement().setAttributeNS(null,"width", 994);
          //ParentGroup1.setAttributeNS(null, "style", "filter:url(#DropShadowFilter)");
          
          //SVGDocument.getElementById("progressbar").setAttributeNS(null,"visibility", "visible");
         
         

          Populate();
         
        }
        

      
      function AddChartValue(Value, Name, Repress)
        {
            Repress = false;
           // alert(Value + "," + Name)
        
          Value = Value * 1;
          if ((Value <= 0) || (isNaN(Value)))
            {
              alert("Negative, textual or null values are not allowed");
              return;
            }
            
          Color = ColorArray[CurrentColor];

          CurrentColor++;
          if (CurrentColor >= ColorArray.length)
          {
           CurrentColor = 0;
          }
          
          
          if (!(Removed))
            {
              Grandparent1.removeChild(ParentGroup1);
              Grandparent2.removeChild(ParentGroup2);
            }
          
          DeleteList[DeleteList.length] = false;
          
          Values[Values.length] = Value * 1;
                          
          PieElements[PieElements.length] = SVGDocument.createElementNS("http://www.w3.org/2000/svg", "path");
          PieElements[PieElements.length - 1].setAttributeNS(null, "style", "stroke:black;cursor:pointer;fill:" + Color);
          Name = Name.replace(/'/g,"\\\'");
          
          //PieElements[PieElements.length - 1].setAttributeNS(null, "onmouseover", "DisplayInfo('" + Name + "', '" + Value + "')");
          //PieElements[PieElements.length - 1].setAttributeNS(null, "onmouseout", "DisplayInfo('', '')");
          

          if (Names.length == 15)
          { // about to add the 16th, make whole list hidden
            while (SVGDocument.getElementById("labels").firstChild) 
             {
                SVGDocument.getElementById("labels").removeChild(SVGDocument.getElementById("labels").firstChild);
             };
            for (var i = 0; i < 15; i++) 
            {
                Colors[i].setAttributeNS(null, "style", "visibility:hidden;");
                Names[i].setAttributeNS(null, "style", "visibility:hidden;");
                SVGDocument.getElementById("labels").appendChild(Colors[i]);
                SVGDocument.getElementById("labels").appendChild(Names[i]);
            }
                       
          }                      

          Names[Names.length] = SVGDocument.createElementNS("http://www.w3.org/2000/svg", "text");
          Colors[Colors.length] = SVGDocument.createElementNS("http://www.w3.org/2000/svg", "rect");
          Names[Names.length - 1].appendChild(SVGDocument.createTextNode(Name + ""));
          //Names[Names.length - 1].setAttributeNS(null, "transform", "rotate(45)");
          
          Colors[Colors.length - 1].setAttributeNS(null,"width",10);
          Colors[Colors.length - 1].setAttributeNS(null,"height",10);
	      Colors[Colors.length - 1].setAttributeNS(null,"fill",Color);
	      Colors[Colors.length - 1].setAttributeNS(null,"stroke","black");
	      Colors[Colors.length - 1].setAttributeNS(null,"stroke-width","1");
	      Colors[Colors.length - 1].setAttributeNS(null,"cursor","pointer");
	      if (Colors.length > 15)
	      {
              Colors[Colors.length - 1].setAttributeNS(null, "style", "visibility:hidden;");
              Names[Names.length - 1].setAttributeNS(null, "style", "visibility:hidden;");
          }
          else
          {
              Colors[Colors.length - 1].setAttributeNS(null, "style", "visibility:visible;");
              Names[Names.length - 1].setAttributeNS(null, "style", "visibility:visible;");
          }
          SVGDocument.getElementById("labels").appendChild(Colors[Colors.length - 1]);
		  
          SVGDocument.getElementById("labels").appendChild(Names[Names.length - 1]);
              
          
          SVGDocument.getElementById("pieitemlabel").setAttributeNS(null, "style", "visibility:visible;");
          
          
          
          
          
          ParentGroup1.appendChild(PieElements[PieElements.length - 1]);
          
          BarElements[BarElements.length] = SVGDocument.createElementNS("http://www.w3.org/2000/svg", "path");
          BarTexts[BarTexts.length] = SVGDocument.createElementNS("http://www.w3.org/2000/svg", "text");
          
          BarElements[BarElements.length - 1].setAttributeNS(null, "style", "stroke:black;cursor:pointer;fill:" + Color);
          BarElements[BarElements.length - 1].setAttributeNS(null, "ID", "id_"+Color );
          //BarElements[BarElements.length - 1].setAttributeNS(null, "onmouseover", "BarTexts[" + (BarTexts.length - 1) + "].getStyle().setProperty('visibility', 'visible', '')");
                    
          //BarElements[BarElements.length - 1].setAttributeNS(null, "onmouseout",  "BarTexts[" + (BarTexts.length - 1) + "].getStyle().setProperty('visibility', 'hidden', '')");
          
      

          ParentGroup2.appendChild(BarElements[BarElements.length - 1]);
          
          BarTexts[BarTexts.length - 1].setAttributeNS(null, "style", "text-anchor:end;font-weight:bold;font-size:13;visibility:hidden");
          BarTexts[BarTexts.length - 1].setAttributeNS(null, "x", "188");
          BarTexts[BarTexts.length - 1].appendChild(SVGDocument.createTextNode(Value + " -"));
          SVGDocument.getElementById("barsidetext").appendChild(BarTexts[BarTexts.length - 1]);
 
          
          Refresh();
          
          if (Repress)
          {
            Removed = true;
          }
          else
          {
              Removed = false;
              Grandparent1.appendChild(ParentGroup1);
              Grandparent2.appendChild(ParentGroup2);
          }
        }
        
      function Refresh()
        {
          PieTotalSize = 0;
          BarTotalSize = 0;
          MaxSize = 0;
          
          for (var I = 0; I < Values.length; I++)
            {
              PieTotalSize += Values[I];
              BarTotalSize++;
              if (Values[I] > MaxSize)
              {
                MaxSize = Values[I];
              }
            }
          
          PieStart = 0;
          BarStart = 0;
          if (PieTotalSize > 0)
          {
            for (var I = 0; I < Values.length; I++)
              {
                PieStart = DrawPieSegment(PieStart, Values[I] / PieTotalSize, PieElements[I], Colors[I], Names[I], I);
                BarStart = DrawBarSegment(BarStart, Values[I] / MaxSize, BarElements[I], BarTexts[I], Colors[I], Names[I], I);
              }
          }
          SVGDocument.getElementById("max").replaceChild(SVGDocument.createTextNode(MaxSize + ""), SVGDocument.getElementById("max").getFirstChild());
          SVGDocument.getElementById("max").setAttributeNS(null, "x", "208");
          SVGDocument.getElementById("max").setAttributeNS(null, "y", "125.5");
          SVGDocument.getElementById("min").replaceChild(SVGDocument.createTextNode("0"), SVGDocument.getElementById("min").getFirstChild());
        }
        
      function DeleteSegment()
        {
          if (ActiveSegment == "Pie")
            {  
              NewValues = new Array();
              NewNames = new Array();
              NewColors = new Array();
              NewPieElements = new Array();
              NewBarElements = new Array();
              NewBarTexts = new Array();
              NewDeleteList = new Array();
              
              SomethingDeleted = false;
              
              CurrentCopySpot = 0;
              for (var I = 0; I < PieElements.length; I++)
                {
                  if (!(DeleteList[I]))
                    {
                      NewValues[CurrentCopySpot] = Values[I];
                      NewNames[CurrentCopySpot] = Names[I];
                      NewColors[CurrentCopySpot] = Colors[I];
                      NewPieElements[CurrentCopySpot] = PieElements[I];
                      NewBarElements[CurrentCopySpot] = BarElements[I];
                      NewBarTexts[CurrentCopySpot] = BarTexts[I];
                      NewDeleteList[CurrentCopySpot] = DeleteList[I];
    
                      NewBarElements[CurrentCopySpot].setAttributeNS(null, "onmouseover", "BarTexts[" + CurrentCopySpot + "].getStyle().setProperty('visibility', 'visible', '')");
                      NewBarElements[CurrentCopySpot].setAttributeNS(null, "onmouseout",  "BarTexts[" + CurrentCopySpot + "].getStyle().setProperty('visibility', 'hidden', '')");
                      CurrentCopySpot++;
                    }
                  else
                    {
                      SomethingDeleted = true;
                      
                      PieElements[I].getParentNode().removeChild(PieElements[I]);
                      BarElements[I].getParentNode().removeChild(BarElements[I]);
                      BarTexts[I].getParentNode().removeChild(BarTexts[I]);
                      Names[I].getParentNode().removeChild(Names[I]);
                      Colors[I].getParentNode().removeChild(Colors[I]);
                    }
                }
              
              if (SomethingDeleted)
                {            
                  Values = NewValues;
                  Names = NewNames;
                  Colors = NewColors;
                  PieElements = NewPieElements;
                  BarElements = NewBarElements;
                  BarTexts = NewBarTexts;
                  DeleteList = NewDeleteList;
              
                  Refresh();
                }
              else
              {
                alert("To delete segments, click on the segments to be deleted to pull them out, then click on the Delete button");
              }
            }
          else
            {
              NewValues = new Array();
              NewNames = new Array();
              NewColors = new Array();
              NewPieElements = new Array();
              NewBarElements = new Array();
              NewBarTexts = new Array();
              NewDeleteList = new Array();
              
              SomethingDeleted = false;
              
              CurrentCopySpot = 0;
              for (var I = 0; I < PieElements.length - 1; I++)
                {
                  NewValues[I] = Values[I];
                  NewNames[I] = Names[I];
                  NewColors[I] = Colors[I];
                  NewPieElements[I] = PieElements[I];
                  NewBarElements[I] = BarElements[I];
                  NewBarTexts[I] = BarTexts[I];
                  NewDeleteList[I] = DeleteList[I];
    
                  NewBarElements[I].setAttributeNS(null, "onmouseover", "BarTexts[" + CurrentCopySpot + "].getStyle().setProperty('visibility', 'visible', '')");
                  NewBarElements[I].setAttributeNS(null, "onmouseout",  "BarTexts[" + CurrentCopySpot + "].getStyle().setProperty('visibility', 'hidden', '')");
                  CurrentCopySpot++;
                }
              if (PieElements.length > 0)
                {
                  SomethingDeleted = true;
                      
                  PieElements[PieElements.length - 1].getParentNode().removeChild(PieElements[PieElements.length - 1]);
                  BarElements[PieElements.length - 1].getParentNode().removeChild(BarElements[PieElements.length - 1]);
                  BarTexts[PieElements.length - 1].getParentNode().removeChild(BarTexts[PieElements.length - 1]);
                  Names[PieElements.length - 1].getParentNode().removeChild(Names[PieElements.length - 1]);
                  Colors[PieElements.length - 1].getParentNode().removeChild(Colors[PieElements.length - 1]);
                }
              
              if (SomethingDeleted)
                {            
                  Values = NewValues;
                  Names = NewNames;
                  Colors = NewColors;
                  PieElements = NewPieElements;
                  BarElements = NewBarElements;
                  BarTexts = NewBarTexts;
                  DeleteList = NewDeleteList;
              
                  Refresh();
                }
            }
        }
        
      function MoveOverEffect(type,i){
          
          if(type=="pie"){Element = this.PieElements[i]};
          if(type=="bar"){Element = this.BarElements[i]};
          
          Element.setAttributeNS(null,"opacity","0.80")
      }
      
      function MoveOutEffect(type,i){
      
          if(type=="pie"){Element = this.PieElements[i]};
          if(type=="bar"){Element = this.BarElements[i]};

          Element.setAttributeNS(null,"opacity","1")
      }
      
      function OverTxtEffect(type,i){

          Element = this.Names[i];
          if (this.Names.length <= 15)
            Element.setAttributeNS(null,"style","visibility:visible;font-weight:bold;")
          else            
            Element.setAttributeNS(null,"style","visibility:hidden;font-weight:bold;")
          
          if(type=="bar"){
              Obj = this.BarTexts[i]
              Obj.setAttributeNS(null,"style","visibility:visible;font-weight:bold;")
              Obj.setAttributeNS(null,"x",175)
          }
      }
      
      function OutTxtEffect(type,i){
      
          Element = this.Names[i];
          if (this.Names.length <= 15)
            Element.setAttributeNS(null,"style","visibility:visible;font-weight:normal;")
          else            
            Element.setAttributeNS(null,"style","visibility:hidden;font-weight:normal;")
          
          if(type=="bar"){
              Obj = this.BarTexts[i]
              Obj.setAttributeNS(null,"style","visibility:hidden;")
          }
      }
      


      function DrawBarSegment(Start, Height, Element, Text, Color, Label, ID)
        {
          XOffset3D = 10;
          YOffset3D = 5;
        
          PathData = "M" + (Start + (BarChartWidth / BarTotalSize)) + ",0";
          PathData = PathData + "h" + (BarChartWidth / BarTotalSize * -1);
          PathData = PathData + "v" + (Height * BarChartHeight * -1);
          PathData = PathData + "l" + XOffset3D + ",-" + YOffset3D;
          PathData = PathData + "h" + (BarChartWidth / BarTotalSize);
          PathData = PathData + "v" + (Height * BarChartHeight);
          PathData = PathData + "l-" + XOffset3D + "," + YOffset3D;
          PathData = PathData + "v" + (Height * BarChartHeight * -1);
          PathData = PathData + "h" + (BarChartWidth / BarTotalSize * -1);
          PathData = PathData + "h" + (BarChartWidth / BarTotalSize);
          PathData = PathData + "l" + XOffset3D + ",-" + YOffset3D;
          PathData = PathData + "l-" + XOffset3D + "," + YOffset3D;
          
          thisValue = this.Values[ID];
          thisName = Label.getFirstChild().data;
          Element.setAttributeNS(null, "d", PathData);
          Element.setAttributeNS(null,"onmouseover","MoveOverEffect('bar',"+ ID +");OverTxtEffect('bar',"+ ID +");DisplayInfo('" + ID + "', '" + thisValue + "', '" + thisName + "')");
          Element.setAttributeNS(null,"onmouseout","MoveOutEffect('bar',"+ ID +");OutTxtEffect('bar',"+ ID +");DisplayInfo('', '', '')");
          
        //  Element.setAttributeNS(null,"onmouseover","OverTxtEffect('bar',"+ ID +")");
        //  Element.setAttributeNS(null,"onmouseout","OutTxtEffect('bar',"+ ID +")");
          
         // Label.setAttributeNS(null, "x", Start / AngleFactor);
         // Label.setAttributeNS(null, "y", Start * -1 / AngleFactor);
         
          Color.setAttributeNS(null, "x", BarChartWidth + 20 );
          Color.setAttributeNS(null, "y", ((Start - 230) + 12) - 20);
         
          Label.setAttributeNS(null, "x", BarChartWidth + 40 );
          Label.setAttributeNS(null, "y", ((Start - 230) + 12) - 10);
          
          Text.setAttributeNS(null, "y", (275 - BarChartHeight * Height));
          
          return Start + BarChartWidth / BarTotalSize;
        }
        
        

        
        
        
      function DrawPieSegment(Start, Size, Element, Color, Label, ID)
        {
        
          PathData = "M0,0L" ;
          PathData = PathData + PieChartSize * Math.sin(Start * Math.PI * 2) + "," + PieChartSize * Math.cos(Start * Math.PI * 2);
//          if (Size >= .5)
//          {
//            PathData = PathData + "A" + PieChartSize + " " + PieChartSize + " 1 1 0 " + PieChartSize * Math.sin((Start + Size) * Math.PI * 2) + "," + PieChartSize * Math.cos((Start + Size) * Math.PI * 2);
//          }
          if (Size >= .5){
          //alert(PieChartSize)
            var SinValue = PieChartSize * Math.sin((Start + Size) * Math.PI * 2);
	        var CosValue = PieChartSize * Math.cos((Start + Size) * Math.PI * 2);

	          if (Math.abs(SinValue) < 0.0001){
		          if(SinValue < 0){
				        SinValue = -0.0001;
		          } 
		          else{
			        SinValue = 0.0001;
		          }
	          } 

	          if (Math.abs(CosValue) < 0.0001){
		          if(CosValue < 0){
				        CosValue = -0.0001;
		          } 
		          else{
			        CosValue = 0.0001;
		          }
	          }
	      
          PathData = PathData + "A" + PieChartSize + " " + PieChartSize + " 1 1 0 " + SinValue + "," + CosValue;
          }
          else
          {
            PathData = PathData + "A" + PieChartSize + " " + PieChartSize + " 0 0 0 " + PieChartSize * Math.sin((Start + Size) * Math.PI * 2) + "," + PieChartSize * Math.cos((Start + Size) * Math.PI * 2);
          }

          
          
          
          
          PathData = PathData + "z";
          //alert(PathData)
          
          Element.setAttributeNS(null, "d", PathData);
          
        thisValue = this.Values[ID];
        thisName = Label.getFirstChild().data;
          Element.setAttributeNS(null,"onmouseover","MoveOverEffect('pie',"+ ID +");OverTxtEffect('pie',"+ ID +");DisplayInfo('" + ID + "', '" + thisValue + "', '" + thisName + "')");
          Element.setAttributeNS(null,"onmouseout","MoveOutEffect('pie',"+ ID +");OutTxtEffect('pie',"+ ID +");DisplayInfo('', '', '')");
          

          
        //  Element.setAttributeNS(null,"onmouseover","DisplayInfo('" + thisName + "', '" + thisValue + "')");
        //  Element.setAttributeNS(null,"onmouseout","DisplayInfo('', '')");
          
   
          
          if (Start > 0)
          {
            Element.setAttributeNS(null, "onclick", "MoveSegment(evt, " + (Start + Size / 2) + ", true, " + ID + ")");
          }
          else
          {
              DeleteList[ID] = true;
              Angle = Start + Size / 2;
            
              X = MoveDistance * Math.sin(Angle * 2 * Math.PI);
              Y = MoveDistance * Math.cos(Angle * 2 * Math.PI);
              Element.setAttributeNS(null, "transform", "translate(" + X + "," + Y + ")");
              Element.setAttributeNS(null, "onclick", "MoveSegment(evt, " + ((Start + Size / 2) * -1) + ", false, " + ID + ")");
          }
          
          return Start + Size;
        }
        
        
      function MoveSegment(MouseEvent, Angle, CanBeDeleted, ID)
        {
          Element = MouseEvent.getTarget();
          if (Angle < 0)
            {
              X = 0;
              Y = 0;
            }
          else
            {
              X = MoveDistance * Math.sin(Angle * 2 * Math.PI);
              Y = MoveDistance * Math.cos(Angle * 2 * Math.PI);
            }
            
          DeleteList[ID] = CanBeDeleted;
          
          Element.setAttributeNS(null, "transform", "translate(" + X + "," + Y + ")");
          Element.setAttributeNS(null, "onclick", "MoveSegment(evt, " + (Angle * -1) + ", " + (!CanBeDeleted) + ", " + ID + ")");
        }
        
      function DisplayInfo(ID, Value, Name)
        {
          
          //Text = this.Names[ID].firstChild.nodeValue
          Text = "Value"
         
        
          if (Text != "")
          {
          
            Percent = " (" + Math.round(Value / PieTotalSize * 10000) / 100 + "%)";
            
          }
          else
          {
            Percent = "";
          }

          if (Name == "")
            NewItem = SVGDocument.createTextNode("");
          else                        
            NewItem = SVGDocument.createTextNode(Value + Percent + ' ' + Name + '' );
          SVGDocument.getElementById("labelamount").replaceChild(NewItem, SVGDocument.getElementById("labelamount").getFirstChild());
          if (Name == "")
            NewItem = SVGDocument.createTextNode("");
          else                        
            NewItem = SVGDocument.createTextNode(Text + "");
          SVGDocument.getElementById("labelitem").replaceChild(NewItem, SVGDocument.getElementById("labelitem").getFirstChild());
          if (Name == "")
            NewItem = SVGDocument.createTextNode("");
          else
            NewItem = SVGDocument.createTextNode(":");
          SVGDocument.getElementById("labelcolon").replaceChild(NewItem, SVGDocument.getElementById("labelcolon").getFirstChild());
          
          SVGDocument.getElementById("pieitemlabel").getStyle().setProperty("visibility", "visible", "");
          
          if(Name == ""){
             SVGDocument.getElementById("pieitemlabel").getStyle().setProperty("visibility", "hidden", "");
          }
        }
        
      function SetTitle(Text)
        {
          NewItem = SVGDocument.createTextNode(Text + "");
          SVGDocument.getElementById("title").replaceChild(NewItem, SVGDocument.getElementById("title").getFirstChild());
        }
        
      function SetAxis(Text)
        {
       
        //  NewItem = SVGDocument.createTextNode(Text + "");
        //  SVGDocument.getElementById("axis").replaceChild(NewItem, SVGDocument.getElementById("axis").getFirstChild());
          //NewItem = SVGDocument.createTextNode(Text + "");
         // SVGDocument.getElementById("subtitle").replaceChild(NewItem, SVGDocument.getElementById("subtitle").getFirstChild());
        }
        
      function ShowPie()
        {
          ActiveSegment = "Pie";
          
          SVGDocument.getElementById("showpierect").getStyle().setProperty("fill", "blue", "");
          SVGDocument.getElementById("showbarrect").getStyle().setProperty("fill", "#FC8D4F", "");
          SVGDocument.getElementById("barchart").getStyle().setProperty("visibility", "hidden", "");
        //  SVGDocument.getElementById("subtitle").getStyle().setProperty("visibility", "visible", "");
          SVGDocument.getElementById("piechart").getStyle().setProperty("visibility", "visible", "");
          SVGDocument.getElementById("pieitemlabel").getStyle().setProperty("visibility", "visible", "");
          SVGDocument.getElementById("barsidetext").getStyle().setProperty("visibility", "hidden", "");
          
         
        }
        
      function ShowBar()
        {
          ActiveSegment = "Bar";
          
       
          SVGDocument.getElementById("showpierect").getStyle().setProperty("fill", "#FC8D4F", "");
          SVGDocument.getElementById("showbarrect").getStyle().setProperty("fill", "blue", "");
          SVGDocument.getElementById("barchart").getStyle().setProperty("visibility", "visible", "");
        //  SVGDocument.getElementById("subtitle").getStyle().setProperty("visibility", "hidden", "");
          SVGDocument.getElementById("piechart").getStyle().setProperty("visibility", "hidden", "");
          SVGDocument.getElementById("pieitemlabel").getStyle().setProperty("visibility", "visible", "");
          SVGDocument.getElementById("barsidetext").getStyle().setProperty("visibility", "visible", "");
         
        }
        
/*      parent.clearChart = ClearChart
      parent.addChartValue = AddChartValue
      parent.setTitle = SetTitle
      parent.setAxis = SetAxis */
    
 