﻿/*
	Licensed Materials - Property of IBM
	editdef.js
	(c) Copyright IBM Corporation 2007, 2008.  All Rights Reserved.
	U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
// JScript File
function GetTextNameFromValue(strValue)
{
    var pos;
    var strName;
    strName = strValue;
    
    pos = strValue.lastIndexOf("("); // DEV_STRING
    if (pos > -1)
    {
        strName = strName.substring(0, pos);
    }
    return strName;
    
}
function exUpClick(CurrentNode)
{
	try
	{
		var ListOfElement;
		var ctlTextBox;
		var nodeID;
		var pos;
		var iIdx;
		var newOption;
		
		nodeID = CurrentNode.id; 
		pos = nodeID.indexOf("_");  // DEV_STRING
		ctlTextBox = document.getElementById(nodeID.substr(0, pos) + "_ctlTextBox"); // DEV_STRING
		ListOfElement = document.getElementById(nodeID.substr(0, pos) + "_ctlListOf"); // DEV_STRING
        if (ListOfElement.selectedIndex != -1)
        {
            iIdx = ListOfElement.selectedIndex;
            ctlTextBox.setAttribute("Save", ListOfElement.options.item(iIdx).value); // DEV_STRING
            ctlTextBox.setAttribute("value", GetTextNameFromValue(ListOfElement.options.item(iIdx).value)); // DEV_STRING
            if (iIdx > 0)
            {
                // newOption = new Option(ListOfElement.options.item(iIdx).text, ListOfElement.options.item(iIdx).value);
                newOption = document.createElement("option");
                newOption.appendChild(document.createTextNode(ListOfElement.options.item(iIdx).text));
                newOption.setAttribute("value", ListOfElement.options.item(iIdx).value);
                ListOfElement.remove(iIdx);
                var prevItem = ListOfElement.options.item(iIdx - 1);
                ListOfElement.insertBefore(newOption, prevItem);
                ListOfElement.options.item(iIdx - 1).selected = true;
            }
            else
            {
                ListOfElement.options.item(0).selected = true;
            }
		}
	}
	catch(e)
	{
	    return false;
	}
	finally
	{
        SettxtListOf(nodeID.substr(0, pos));
	    return false;
	}
}
function exDownClick(CurrentNode)
{
	try
	{
		var ListOfElement;
		var ctlTextBox;
		var nodeID;
		var pos;
		var iIdx;
		var newOption;
		
		nodeID = CurrentNode.id; 
		pos = nodeID.indexOf("_"); // DEV_STRING
		ctlTextBox = document.getElementById(nodeID.substr(0, pos) + "_ctlTextBox"); // DEV_STRING
		ListOfElement = document.getElementById(nodeID.substr(0, pos) + "_ctlListOf"); // DEV_STRING
        if (ListOfElement.selectedIndex != -1)
        {
            iIdx = ListOfElement.selectedIndex;
            ctlTextBox.setAttribute("Save", ListOfElement.options.item(iIdx).value); // DEV_STRING
            ctlTextBox.setAttribute("value", GetTextNameFromValue(ListOfElement.options.item(iIdx).value)); // DEV_STRING
            if (iIdx < ListOfElement.options.length - 1)
            {
                newOption = document.createElement("option");
                newOption.appendChild(document.createTextNode(ListOfElement.options.item(iIdx).text));
                newOption.setAttribute("value", ListOfElement.options.item(iIdx).value);
                ListOfElement.remove(iIdx);
                if (iIdx >= ListOfElement.options.length - 1)
                {
                    ListOfElement.appendChild(newOption);
                    ListOfElement.selectedIndex = ListOfElement.options.length - 1;
                }
                else
                {
                    var nextItem = ListOfElement.options.item(iIdx + 1);
                    ListOfElement.insertBefore(newOption, nextItem);
                }
                    ListOfElement.options.item(iIdx + 1).selected = true;
            }
            else
            {
                ListOfElement.options.item(ListOfElement.options.length - 1).selected = true;
            }
		}
	}
	catch(e)
	{
	    return false;
	}
	finally
	{
        SettxtListOf(nodeID.substr(0, pos));
	    return false;
	}
}
function exRemoveOneOfClick(CurrentNode)
{
	try
	{
		var ctlTextBox;
		var ctlTextFName;
		var ctlBtn;
		var ctlDefineBtn;
		
		nodeID = CurrentNode.id; 
		pos = nodeID.indexOf("_"); // DEV_STRING
		ctlTextBox = document.getElementById(nodeID.substr(0, pos) + "_ctlTextBox"); // DEV_STRING
        ctlTextBox.setAttribute("Save", ""); // DEV_STRING
        ctlTextBox.setAttribute("value", ""); // DEV_STRING
		ctlTextFName = document.getElementById(nodeID.substr(0, pos) + "_ctlTextFName"); // DEV_STRING
        ctlTextFName.setAttribute("value", ""); // DEV_STRING
        ctlBtn = document.getElementById(nodeID.substr(0, pos) + "_btnRemove"); // DEV_STRING
		ctlDefineBtn = document.getElementById(nodeID.substr(0, pos) + "_btnDefine"); // DEV_STRING
		ctlBtn.disabled = true; // DEV_STRING
        ctlDefineBtn.disabled = true; // DEV_STRING
        
        
	}
	catch(e)
	{
	    return false;
	}
	finally
	{
	    return false;
	}
}
function exRemoveClick(CurrentNode)
{
	try
	{
		var ListOfElement;
		var ctlTextBox;
		var nodeID;
		var pos;
		var iIdx;
		var ctlDefineBtn;
		
        nodeID = CurrentNode.id; 
		pos = nodeID.indexOf("_"); // DEV_STRING
		ctlTextBox = document.getElementById(nodeID.substr(0, pos) + "_ctlTextBox"); // DEV_STRING
		ctlDefineBtn = document.getElementById(nodeID.substr(0, pos) + "_btnDefine"); // DEV_STRING
		ListOfElement = document.getElementById(nodeID.substr(0, pos) + "_ctlListOf"); // DEV_STRING
        if (ListOfElement.selectedIndex != -1)
        {
            iIdx = ListOfElement.selectedIndex;
            ListOfElement.remove(iIdx);

            // Rebuild the list because there is a problem with removing from the list control.
            // if not at the top of the list and remove the first visible entry then a blank line appears
            // as if the control is not redrawn
            var txt = new Array();
            var val = new Array();
		    for (var i = ListOfElement.options.length-1; i >= 0; i--)
		    {
		        txt.push(ListOfElement.options[i].text);
		        val.push(ListOfElement.options[i].value);
                ListOfElement.remove(i);
            }
            
            ListOfElement.length = 0;

		    while (val.length > 0)
		    {
		        var valx = val.pop();
		        var txtx = txt.pop();
                var newOption = new Option(txtx, valx);
                ListOfElement.options.add(newOption, ListOfElement.options.length);
            }
            if (ListOfElement.options.length > 0)
            {
                if (iIdx > 0)
                    iIdx = iIdx -1;
                ctlTextBox.setAttribute("Save", ListOfElement.options.item(iIdx).value); // DEV_STRING
                ctlTextBox.setAttribute("value", GetTextNameFromValue(ListOfElement.options.item(iIdx).value)); // DEV_STRING
                ListOfElement.options.item(iIdx).selected = true;
                if (bEnableDefine(ListOfElement.options.item(iIdx).value))
                    ctlDefineBtn.disabled = false; // DEV_STRING
                else
                    ctlDefineBtn.disabled = true; // DEV_STRING
            }
            else
                ctlTextBox.value = ""; // DEV_STRING
		}
	}
	catch(e)
	{
	    return false;
	}
	finally
	{
        SettxtListOf(nodeID.substr(0, pos));
	    return false;
	}
}
function exAddClick(CurrentNode)
{
	try
	{
		var ListOfElement;
		var ctlTextBox;
		var nodeID;
		var pos;
		var iIdx;
		var bFound;
		var strValue;
		var button;
		var serverControl;
		var iLen;
		var ctlDefineBtn;
		
		nodeID = CurrentNode.id; 
		pos = nodeID.indexOf("_"); // DEV_STRING
		ctlTextBox = document.getElementById(nodeID.substr(0, pos) + "_ctlTextBox"); // DEV_STRING
		ctlDefineBtn = document.getElementById(nodeID.substr(0, pos) + "_btnDefine"); // DEV_STRING
		strValue = ctlTextBox.value;
  	    iLen = strValue.length;    	    
        for (iIdx=0; iIdx < iLen; iIdx++)
        {
            if (strValue.substr(iIdx,1) != " ")
                break;
        }
        if (iIdx > 0)
        {
            strValue = strValue.substr(iIdx);
        }
        iLen = strValue.length;    	    
        for (iIdx=iLen-1; iIdx != 0; iIdx--)
        {
            if (strValue.substr(iIdx,1) != " ")
                break;
        }
        if (iIdx < iLen - 1)
        {
            strValue = strValue.substr(0, iIdx+1);
        }
        if (strValue=="")
        {
    	    return false;
    	}
		
		button = nodeID.substr(0, pos) + "_ctlListOf"; // DEV_STRING
		serverControl = nodeID.substr(0, pos) + "$ctlListOf"; // DEV_STRING
		ListOfElement = document.getElementById(button);
		bFound = false;
		for (iIdx = 0; iIdx < ListOfElement.options.length; iIdx++)
		{
		    if (strValue == ListOfElement.options.item(iIdx).text)
		        bFound = true;
		}
		if (bFound == false)
	    {
    		var newOption;
            newOption = new Option(strValue, strValue + "(0)F");
            ListOfElement.options.add(newOption, ListOfElement.options.length);
            ListOfElement.options.item(ListOfElement.options.length-1).selected = true;
            ctlTextBox.value = ""; // DEV_STRING
            ctlTextBox.setAttribute("Save", ""); // DEV_STRING
            ctlDefineBtn.disabled = true; // DEV_STRING
    	    CallServer(serverControl, strValue + "(0)F");
        }
	}
	catch(e)
	{
	    return false;
	}
	finally
	{
        SettxtListOf(nodeID.substr(0, pos));
	    return false;
	}
}
function exSelectClick(bListOf, CurrentNode)
{
	try
	{
		var ListOfElement;
		var ctlTextBox;
		var ctlTextFName;
		var ChoicesList;
		var nodeID;
		var pos;
		var iIdx;
		var bFound;
		var strValue;
		var button;
	    var serverControl;
		var strBuffer;
		var iNameLen;
		var strType;
		var strName;
		var ctlDefineBtn;
		var ctlRemoveBtn;
		var strFound;
		
		nodeID = CurrentNode.id; 
		pos = nodeID.indexOf("_"); // DEV_STRING
		ctlTextBox = document.getElementById(nodeID.substr(0, pos) + "_ctlTextBox"); // DEV_STRING
		ChoicesList = document.getElementById(nodeID.substr(0, pos) + "_ctlList"); // DEV_STRING
		button = nodeID.substr(0, pos) + "_ctlListOf"; // DEV_STRING
		serverControl = nodeID.substr(0, pos) + "$ctlListOf"; // DEV_STRING
		ctlDefineBtn = document.getElementById(nodeID.substr(0, pos) + "_btnDefine"); // DEV_STRING
		ListOfElement = document.getElementById(button);
        if (ChoicesList.selectedIndex != -1)
        {
	        strBuffer = ""; // DEV_STRING
	        strFound = ""; // DEV_STRING
		    for (iIdx = 0; iIdx < ChoicesList.options.length; iIdx++)
		    {
		        if (ChoicesList.options.item(iIdx).selected == true)
		        {
		            strValue = GetTextNameFromValue(ChoicesList.options.item(iIdx).value);
		            strType = "";
		            strName = strValue;
		            if (bListOf == false)
		            { // HeteroListOf
		                iNameLen = strValue.indexOf(":");
		                if (iNameLen > -1)
		                {
		                    strType = strValue.substring(iNameLen + 1);
		                    iNameLen = strType.indexOf(":");
    		                if (iNameLen > -1)
    		                {
		                        strName = strType.substring(iNameLen + 1);
		                        strType = strType.substring(0, iNameLen);
		                        strName = strName + " [" + strType + "]";
		                    }
		                }
		            }
                    if (ListOfElement != null)
                    {
		                bFound = false;
		                for (iIdx2 = 0; iIdx2 < ListOfElement.options.length; iIdx2++)
		                {
		                    if (strValue == GetTextNameFromValue(ListOfElement.options.item(iIdx2).value))
		                    {
		                        bFound = true;
		                        strFound = strFound + "\r\n" + GetTextNameFromValue(ChoicesList.options.item(iIdx).value);
		                    }
		                }
		                if (bFound == false)
	                    {
    		                var newOption;
                            newOption = new Option(strName, ChoicesList.options.item(iIdx).value);
                            ListOfElement.options.add(newOption, ListOfElement.options.length);
                            ListOfElement.options.item(ListOfElement.options.length-1).selected = true;
                            ctlTextBox.setAttribute("Save", ChoicesList.options.item(iIdx).value); // DEV_STRING
                            ctlTextBox.setAttribute("value", GetTextNameFromValue(ChoicesList.options.item(iIdx).value)); // DEV_STRING
                            if (strBuffer != "")     // DEV_STRING
                                strBuffer = strBuffer + "~@#!^~!"; // DEV_STRING
                            strBuffer = strBuffer + ChoicesList.options.item(iIdx).value;                                
                            if (bEnableDefine(ChoicesList.options.item(iIdx).value))
                                ctlDefineBtn.disabled = false; // DEV_STRING
                            else
                                ctlDefineBtn.disabled = true; // DEV_STRING
	                    }
	                }
	                else // this should be OneOF
	                {
                        ctlTextBox.setAttribute("Save", ChoicesList.options.item(iIdx).value); // DEV_STRING
                        ctlTextBox.setAttribute("value", GetTextNameFromValue(ChoicesList.options.item(iIdx).value)); // DEV_STRING
                        ctlTextFName = document.getElementById(nodeID.substr(0, pos) + "_ctlTextFName"); // DEV_STRING
                        ctlTextFName.setAttribute("value", ChoicesList.options.item(iIdx).value); // DEV_STRING
                        if (bEnableDefine(ChoicesList.options.item(iIdx).value))
                            ctlDefineBtn.disabled = false; 
                        else
                            ctlDefineBtn.disabled = true; 
               		    ctlRemoveBtn = document.getElementById(nodeID.substr(0, pos) + "_btnRemove"); // DEV_STRING
               		    ctlRemoveBtn.disabled = false;
                    }
		        }
		    }
            if (ListOfElement != null && (strBuffer != "" || strFound != "")) // DEV_STRING
            {
                CallServer(strFound + "()" + serverControl, strBuffer);
            }                
            
		}
		ChoicesList.selectedIndex = -1;
	}
	catch(e)
	{
	    return false;
	}
	finally
	{
        SettxtListOf(nodeID.substr(0, pos));
	    return false;
	}
}
function exCloseClick(CurrentNode)
{
	try
	{
		var ChoicesList;
		var ChoicesBtn;
		var DifineBtn;
		var txtChoiceStatus;
		var nodeID;
		var pos;
		var iIdx;
		
		nodeID = CurrentNode.id; 
		pos = nodeID.indexOf("_"); // DEV_STRING
		ChoicesList = document.getElementById(nodeID.substr(0, pos) + "_ChoicesList"); // DEV_STRING
        ChoicesList.style.display = "none";		 // DEV_STRING
        ChoicesBtn = document.getElementById(nodeID.substr(0, pos) + "_btnChoices"); // DEV_STRING
        DifineBtn = document.getElementById(nodeID.substr(0, pos) + "_btnDefine"); // DEV_STRING
        ChoicesBtn.disabled = false;

        txtChoiceStatus = document.getElementById(nodeID.substr(0, pos) + "_txtChoiceStatus");
        
        if (txtChoiceStatus != null) {
            txtChoiceStatus.setAttribute("value", "y");
            //DifineBtn.disabled = false;
        }
        //else  DifineBtn.disabled = true;
	}
	catch(e)
	{
	    return false;
	}
	finally
	{
	    return false;
	}
}
function exListClick(ListOfElement)
{
    try
	{
		var ctlTextBox;
		var nodeID;
		var pos;
		var iIdx;
		var strName;
		var ctlDefineBtn;
		var ctlRemoveBtn;
		
		nodeID = ListOfElement.id; 
		pos = nodeID.indexOf("_"); // DEV_STRING
		ctlTextBox = document.getElementById(nodeID.substr(0, pos) + "_ctlTextBox"); // DEV_STRING
		ctlDefineBtn = document.getElementById(nodeID.substr(0, pos) + "_btnDefine"); // DEV_STRING
    	ctlRemoveBtn = document.getElementById(nodeID.substr(0, pos) + "_btnRemove"); // DEV_STRING
        if (ListOfElement.selectedIndex != -1)
        {
            iIdx = ListOfElement.selectedIndex;
            strName = GetTextNameFromValue(ListOfElement.options.item(iIdx).value);
            ctlTextBox.setAttribute("Save", ListOfElement.options.item(iIdx).value); // DEV_STRING
            ctlTextBox.setAttribute("value", GetTextNameFromValue(ListOfElement.options.item(iIdx).value)); // DEV_STRING
            if (bEnableDefine(ListOfElement.options.item(iIdx).value))
                ctlDefineBtn.disabled = false; // DEV_STRING
            else
                ctlDefineBtn.disabled = true; // DEV_STRING
    		ctlRemoveBtn.disabled = false;
		}
		else
		{
    		ctlDefineBtn.disabled = true;
    		ctlRemoveBtn.disabled = true;
    	}
	}
	catch(e)
	{
	    return false;
	}
    finally
	{
	    return false;
	}
}
function GetDDIDFromValue(strValue)
{
    var pos;
    var strDDID;
    strDDID = "0";
    
    pos = strValue.lastIndexOf("("); // DEV_STRING
    if (pos > -1)
    {
        strValue = strValue.substring(pos+1);
        pos = strValue.indexOf(")");
        strDDID = strValue.substring(0, pos);
    }
    return strDDID;
    
}
function bEnableDefine(strValue)
{
    var pos;
    var strDDID;
    strDDID = "0";
    
    pos = strValue.lastIndexOf("("); // DEV_STRING
    if (pos > -1)
    {
        strValue = strValue.substring(pos+1);
        pos = strValue.indexOf(")");
        strDDID = strValue.substring(0, pos);
    }
    if (strDDID == "0")
        return 0;
        
    if (strValue.substring(pos+1) == "T")
        return 0;
        
    return 1;
    
}
function setDisableDefine(ctlTextBox, ev)
{
    try
	{
		var nodeID;
		var pos;
		var ctlDefineBtn;
           var k;

        if(document.all) 
            k = window.event.keyCode;  //IE
        else 
            k = ev.which ;             //FF
		
		if (k != 9) // Tabs can be ignored
		{
    	    nodeID = ctlTextBox.id; 
		    pos = nodeID.indexOf("_"); // DEV_STRING
		    ctlDefineBtn = document.getElementById(nodeID.substr(0, pos) + "_btnDefine"); // DEV_STRING
            ctlDefineBtn.disabled = true; // DEV_STRING
        }
	}
	catch(e)
	{
	    return false;
	}
    finally
	{
	    return false;
	}
}
function exDefineClick(CurrentNode, Class)
{
	try
	{
		var ListOfElement;
		var nodeID;
		var pos;
		var iIdx;
		var DDID;
		
		nodeID = CurrentNode.id; 
		pos = nodeID.indexOf("_"); // DEV_STRING
		ListOfElement = document.getElementById(nodeID.substr(0, pos) + "_ctlListOf"); // DEV_STRING
        if (ListOfElement.selectedIndex != -1)
        {
            iIdx = ListOfElement.selectedIndex;
            DDID = GetDDIDFromValue(ListOfElement.options.item(iIdx).value); // DEV_STRING
            if (DDID != "0")
            {            
                var buffer;
                var  newWin;
             
                buffer =  "./editdef_lock.aspx?ddid=" + DDID; //DEV_STRING
                
                if (Class == "Diagram") {         //DEV_STRING 
                // this can't happen, the Define button for ref props is not visible
                    buffer = buffer + "&isDiag=y"; //DEV_STRING
                    newWin = window.open(buffer);
                    }
               else{
                    newWin = window.open(buffer); 
                   }
            }
		}
	}
	catch(e)
	{
	    return false;
	}
	finally
	{
	    return false;
	}
}
function exDefineOneOfClick(CurrentNode, Class)
{
	try
	{
		var ctlTextFName;
		var nodeID;
		var pos;
		var iIdx;
		var DDID;
		
		nodeID = CurrentNode.id; 
		pos = nodeID.indexOf("_"); // DEV_STRING
		ctlTextFName = document.getElementById(nodeID.substr(0, pos) + "_ctlTextFName"); // DEV_STRING
        DDID = GetDDIDFromValue(ctlTextFName.getAttribute("value")); // DEV_STRING
        if (DDID != "0")
        {            
             var buffer;
             var  newWin;
             
             buffer =  "./editdef_lock.aspx?ddid=" + DDID; //DEV_STRING
                
                if (Class == "Diagram") {         //DEV_STRING 
                // this can't happen, the Define button for ref props is not visible
                    buffer = buffer + "&isDiag=y"; //DEV_STRING
                    newWin = window.open(buffer);
                    }
                else{
                    newWin = window.open(buffer); 
                   }
        }
	}
	catch(e)
	{
	    return false;
	}
	finally
	{
	    return false;
	}
}
function SettxtListOf(nodePfx)
{
	try
	{
        var iIdx;
        var strValue;
        var ctlTextBox;
        var ctlListOf;
        var ctlBtn;
		ctlListOf = document.getElementById(nodePfx + "_ctlListOf"); // DEV_STRING
		ctlTextBox = document.getElementById(nodePfx + "_txtListOf"); // DEV_STRING
        strValue = ""; // DEV_STRING
        for (iIdx = 0; iIdx < ctlListOf.options.length; iIdx++)
        {
            if (strValue != "") // DEV_STRING
            {
                strValue = strValue + "~@#!^~!"; // DEV_STRING
            }
            strValue = strValue + ctlListOf.options.item(iIdx).value;
        }
        ctlTextBox.setAttribute("value", strValue); // DEV_STRING
        if (ctlListOf.selectedIndex < 0)
        {
    		ctlBtn = document.getElementById(nodePfx + "_btnDefine"); // DEV_STRING
    		ctlBtn.disabled = true;
    		ctlBtn = document.getElementById(nodePfx + "_btnRemove"); // DEV_STRING
    		ctlBtn.disabled = true;
        }
        else
        {
    		ctlBtn = document.getElementById(nodePfx + "_btnRemove"); // DEV_STRING
    		ctlBtn.disabled = false;
        }
	}
	catch(e)
	{
//		alert("@Error@: " + "\n Name: " + e.name + "\n Error Description: " + e.message + "\n Error number: " + e.number);
	    return false;
	}
}
function ReceiveServerDataNewdef(rValue)
{
}
function ReceiveServerData(rValue)
{
    if (rValue != "")
        alert(rValue);
}

function exEnterKey(CurrentNode, ev)
{
   var k;

   if(document.all) k = window.event.keyCode;  //IE
   else k = ev.which ;                        //FF

   if (k == 13)
    {
        exAddClick(CurrentNode);
        return false;
    }
        else return true;

}



